//sram_test.c
#include "sram_test.h"
#include <iolpc2214.h>

#define SRAM_SIZE     0x100000         // Total area of Flash region in words 8 bit
#define SRAM_BASE     0x81000000       //First 0x8000 bytes reserved for boot loader etc.

void WriteByteSRAM(unsigned long* Add, unsigned char uiData)
{
  //later
}

unsigned char ReadByteSRAM(unsigned long* Add)
{
  //later
  return 0;
}


void WriteSRAM(unsigned long* Add, unsigned long uiData)
{
  *Add = uiData;
}

unsigned long ReadSRAM(unsigned long* Add)
{
  return *Add;
}

unsigned char TestSRAM()
{

  unsigned long i       = 0;      //need for cycles
  unsigned long* pAdd   = 0;      //pointer to SRAM

  //write data to SRAM
  for(i=0, pAdd=(unsigned long *)SRAM_BASE; pAdd < (unsigned long *)SRAM_BASE+SRAM_SIZE/4; ++pAdd,++i)
  {
    WriteSRAM(pAdd, i);
  }

  //read data from SRAM
  for(i=0, pAdd=(unsigned long *)SRAM_BASE; pAdd < (unsigned long *)SRAM_BASE+SRAM_SIZE/4; ++pAdd,++i)
  {
     if (*pAdd != i) break;
  }

  //compare read and write data
  //if data is same pAdd will reach last address
   if (pAdd >= (unsigned long *)SRAM_BASE+SRAM_SIZE/4)
   {
     return 1;
   }
   else
   {
     return 0;
   }

}

